<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: SR_CotizacionDevolucionCab.xml */
/* Generado: 2021-06-25 09:58:00 */

/* Mantenimiento de los registros de la tabla SR_CotizacionDevolucionCab */
abstract class BaseSR_CotizacionDevolucionCabDP extends SR_CotizacionDevolucionCabBV
{
    /* Constructor ( Establece los valores desde un objeto SR_CotizacionDevolucionCabBN ) */
    public function __construct( SR_CotizacionDevolucionCabBN $o_SR_CotizacionDevolucionCabBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_SR_CotizacionDevolucionCabBN ) )
        {
            $this->setByBN( $o_SR_CotizacionDevolucionCabBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto SR_CotizacionDevolucionCabBN */
    public function setByBN( SR_CotizacionDevolucionCabBN $o_SR_CotizacionDevolucionCabBN )
    {
        if ( !is_null( $o_SR_CotizacionDevolucionCabBN->getCotiDevolucionId() ) )
        {
            $this->setCotiDevolucionId( $o_SR_CotizacionDevolucionCabBN->getCotiDevolucionId() );
        }
        if ( !is_null( $o_SR_CotizacionDevolucionCabBN->getIdProyecto() ) )
        {
            $this->setIdProyecto( $o_SR_CotizacionDevolucionCabBN->getIdProyecto() );
        }
        if ( !is_null( $o_SR_CotizacionDevolucionCabBN->getNumeroDocumento() ) )
        {
            $this->setNumeroDocumento( $o_SR_CotizacionDevolucionCabBN->getNumeroDocumento() );
        }
        if ( !is_null( $o_SR_CotizacionDevolucionCabBN->getOrdenId() ) )
        {
            $this->setOrdenId( $o_SR_CotizacionDevolucionCabBN->getOrdenId() );
        }
        if ( !is_null( $o_SR_CotizacionDevolucionCabBN->getOrdenTipoComercialId() ) )
        {
            $this->setOrdenTipoComercialId( $o_SR_CotizacionDevolucionCabBN->getOrdenTipoComercialId() );
        }
        if ( !is_null( $o_SR_CotizacionDevolucionCabBN->getOrdenTipoClasificacionId() ) )
        {
            $this->setOrdenTipoClasificacionId( $o_SR_CotizacionDevolucionCabBN->getOrdenTipoClasificacionId() );
        }
        if ( !is_null( $o_SR_CotizacionDevolucionCabBN->getIdItem() ) )
        {
            $this->setIdItem( $o_SR_CotizacionDevolucionCabBN->getIdItem() );
        }
        if ( !is_null( $o_SR_CotizacionDevolucionCabBN->getIdUnidad() ) )
        {
            $this->setIdUnidad( $o_SR_CotizacionDevolucionCabBN->getIdUnidad() );
        }
        if ( !is_null( $o_SR_CotizacionDevolucionCabBN->getItemDescripcion() ) )
        {
            $this->setItemDescripcion( $o_SR_CotizacionDevolucionCabBN->getItemDescripcion() );
        }
        if ( !is_null( $o_SR_CotizacionDevolucionCabBN->getContadorGuia() ) )
        {
            $this->setContadorGuia( $o_SR_CotizacionDevolucionCabBN->getContadorGuia() );
        }
        if ( !is_null( $o_SR_CotizacionDevolucionCabBN->getCantidadPedida() ) )
        {
            $this->setCantidadPedida( $o_SR_CotizacionDevolucionCabBN->getCantidadPedida() );
        }
        if ( !is_null( $o_SR_CotizacionDevolucionCabBN->getCantidadDevuelto() ) )
        {
            $this->setCantidadDevuelto( $o_SR_CotizacionDevolucionCabBN->getCantidadDevuelto() );
        }
        if ( !is_null( $o_SR_CotizacionDevolucionCabBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_SR_CotizacionDevolucionCabBN->getFechaCreacion() );
        }
        if ( !is_null( $o_SR_CotizacionDevolucionCabBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_SR_CotizacionDevolucionCabBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_SR_CotizacionDevolucionCabBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_SR_CotizacionDevolucionCabBN->getFechaModificacion() );
        }
        if ( !is_null( $o_SR_CotizacionDevolucionCabBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_SR_CotizacionDevolucionCabBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_SR_CotizacionDevolucionCabFN = new SR_CotizacionDevolucionCabFN();
        $o_SR_CotizacionDevolucionCabBN = $o_SR_CotizacionDevolucionCabFN->selectByPk( $this->getCotiDevolucionId() );
        if ( is_null( $o_SR_CotizacionDevolucionCabBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO SR_CotizacionDevolucionCab ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getCotiDevolucionId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CotiDevolucionId";
                $s_SQLQuery2 .= $s_Separator."".$this->getCotiDevolucionId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdProyecto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdProyecto";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdProyecto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroDocumento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NumeroDocumento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNumeroDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getOrdenId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."OrdenId";
                $s_SQLQuery2 .= $s_Separator."".$this->getOrdenId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getOrdenTipoComercialId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."OrdenTipoComercialId";
                $s_SQLQuery2 .= $s_Separator."".$this->getOrdenTipoComercialId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getOrdenTipoClasificacionId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."OrdenTipoClasificacionId";
                $s_SQLQuery2 .= $s_Separator."".$this->getOrdenTipoClasificacionId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdItem";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdUnidad() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdUnidad";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdUnidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getItemDescripcion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ItemDescripcion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getItemDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getContadorGuia() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ContadorGuia";
                $s_SQLQuery2 .= $s_Separator."".$this->getContadorGuia()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadPedida() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CantidadPedida";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidadPedida()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadDevuelto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CantidadDevuelto";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidadDevuelto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE SR_CotizacionDevolucionCab SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdProyecto() ) )
            {
                $s_SQLQuery .= $s_Separator."IdProyecto = ".$this->getIdProyecto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroDocumento() ) )
            {
                $s_SQLQuery .= $s_Separator."NumeroDocumento = '".$this->getNumeroDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getOrdenId() ) )
            {
                $s_SQLQuery .= $s_Separator."OrdenId = ".$this->getOrdenId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getOrdenTipoComercialId() ) )
            {
                $s_SQLQuery .= $s_Separator."OrdenTipoComercialId = ".$this->getOrdenTipoComercialId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getOrdenTipoClasificacionId() ) )
            {
                $s_SQLQuery .= $s_Separator."OrdenTipoClasificacionId = ".$this->getOrdenTipoClasificacionId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdItem() ) )
            {
                $s_SQLQuery .= $s_Separator."IdItem = '".$this->getIdItem()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdUnidad() ) )
            {
                $s_SQLQuery .= $s_Separator."IdUnidad = ".$this->getIdUnidad()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getItemDescripcion() ) )
            {
                $s_SQLQuery .= $s_Separator."ItemDescripcion = '".$this->getItemDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getContadorGuia() ) )
            {
                $s_SQLQuery .= $s_Separator."ContadorGuia = ".$this->getContadorGuia()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadPedida() ) )
            {
                $s_SQLQuery .= $s_Separator."CantidadPedida = ".$this->getCantidadPedida()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadDevuelto() ) )
            {
                $s_SQLQuery .= $s_Separator."CantidadDevuelto = ".$this->getCantidadDevuelto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  CotiDevolucionId = ".$this->getCotiDevolucionId().";";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM SR_CotizacionDevolucionCab WHERE  CotiDevolucionId = ".$this->getCotiDevolucionId().";";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>